﻿//////////////////////////////////////////////
// PbsProgramTracker.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkAstraeus
{
	struct PbsMaterialInfo ;
}

namespace nkGraphics
{
	class Program ;
}

/// Includes ---------------------------------

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// Standards
#include <unordered_map>

/// Internals --------------------------------

namespace nkAstraeus
{
	struct PbsProgramEntry
	{
		nkGraphics::Program* _program = nullptr ;
		unsigned int _count = 0 ;
	} ;
}

/// Class ------------------------------------

namespace nkAstraeus
{
	class PbsProgramTracker final : public nkCommon::SingletonClass<PbsProgramTracker>
	{
		friend class nkCommon::SingletonClass<PbsProgramTracker> ;

		private :

			// Attributes
			// Memory of programs
			std::unordered_map<unsigned long long, PbsProgramEntry> _programs ;

		private :

			// Functions
			// Constructor, destructor
			PbsProgramTracker () ;
			~PbsProgramTracker () ;

		public :

			// Management
			nkGraphics::Program* getProgram (const PbsMaterialInfo& info) ;
			void releaseProgram (const PbsMaterialInfo& info) ;
	} ;
}