﻿//////////////////////////////////////////////
// JsonExporter.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkExport
{
	class Exportable ;
	class Node ;
}

/// Includes ---------------------------------

// nkExport
#include "../Dll/DllDefines.h"

#include "ExporterLoadResult.h"

// Standard
#include <string_view>

/// Class ------------------------------------

namespace nkExport
{
	class DLL_EXPORT_EXPORT JsonExporter final
	{
		private :

			// Constructeur, destructeur
			JsonExporter () = delete ;
			~JsonExporter () = delete ;
			
		public :

			// Export
			static std::string exportObjectIntoString (Exportable* toExport) ;
			static std::string exportTreeIntoString (Node* rootNode) ;
			// Import
			static ExporterLoadResult importIntoTree (const std::string_view& strVal) ;
	} ;
}