﻿//////////////////////////////////////////////
// MeshLoader.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkExport
{
	class Node ;
}

namespace nkGraphics
{
	class Mesh ;
	class MeshLoadQuery ;
	class MeshLoadResult ;
	class MeshSaveQuery ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../../Dll/DllDefines.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// Standards
#include <string>
#include <vector>

/// Class ------------------------------------

namespace nkGraphics
{	
	class DLL_GRAPHICS_EXPORT MeshLoader final
	{
		private :

			// Constructeur, destructeur
			MeshLoader () = delete ;
			~MeshLoader () = delete ;
		
		public :
		
			// Fill
			static bool fillBufferFromFile (Mesh* mesh, const std::string_view& pathFromData) ;

			// Load générique
			static MeshLoadResult loadMesh (const MeshLoadQuery& query) ;
	} ;
}