﻿//////////////////////////////////////////////
// MonoMaterialPass.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Shader ;
}

/// Includes ---------------------------------

// nkGraphics
#include "RenderScenePass.h"

#include "../Dll/DllDefines.h"

/// Class ------------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT MonoMaterialPass : public RenderScenePass
	{
		protected :		
		
			// Attributs
			// Le shader à utiliser
			Shader* _linkedShader ;

		protected :

			// Constructor, destructor
			MonoMaterialPass () ;
			virtual ~MonoMaterialPass () ;
		
		public :			

			// Getters
			Shader* getLinkedShader () const ;

			// Setters
			virtual void setLinkedShader (Shader* shade) ;

			// L'export et import
			virtual void exportClassToTree (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}