﻿//////////////////////////////////////////////
// LambdaTask.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkTasks
#include "../Dll/DllDefines.h"

#include "Task.h"

// Standards
#include <functional>

/// Class ------------------------------------

namespace nkTasks
{
	class DLL_TASKS_EXPORT LambdaTask : public Task
	{
		private :
		
			// Les callbacks utilisés
			std::function<TASK_RESULT()> _workFunc ;
			std::function<void()> _workDoneFunc ;
			std::function<void()> _successFunc ;
			std::function<void()> _failFunc ;
			std::function<void()> _abortFunc ;
			
		public :
		
			// Constructeur, destructeur
			LambdaTask () ;
			~LambdaTask () ;

			// Réimplémentation des fonctions mères
			virtual TASK_RESULT onWork () override ;
			virtual void onWorkDone () override ;
			virtual void onSuccess () override ;
			virtual void onFail () override ;
			virtual void onAbort () override ;

			// Setters
			void setWorkFunc (std::function<TASK_RESULT()> func) ;
			void setWorkDoneFunc (std::function<void()> func) ;
			void setSuccessFunc (std::function<void()> func) ;
			void setFailFunc (std::function<void()> func) ;
			void setAbortFunc (std::function<void()> func) ;
	} ;
}